VERSION 5.00
Begin VB.UserControl BC 
   ClientHeight    =   615
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1515
   ScaleHeight     =   41
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   101
   Begin VB.PictureBox picPopup 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   2805
      Left            =   0
      Picture         =   "BC.ctx":0000
      ScaleHeight     =   187
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   190
      TabIndex        =   0
      Top             =   300
      Visible         =   0   'False
      Width           =   2850
   End
End
Attribute VB_Name = "BC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type LOGBRUSH
    lbStyle As Long
    lbColor As Long
    lbHatch As Long
End Type
' 
Private Declare Function DrawEdge Lib "user32" ( _
   ByVal hdc As Long, _
   qrc As RECT, _
   ByVal edge As Long, _
   ByVal grfFlags As Long) _
   As Long
Private Declare Function SetRect Lib "user32" ( _
   lpRect As RECT, _
   ByVal X1 As Long, _
   ByVal Y1 As Long, _
   ByVal X2 As Long, _
   ByVal Y2 As Long) _
   As Long
' 
Private Declare Function FillRect Lib "user32" ( _
    ByVal hdc As Long, _
    lpRect As RECT, _
    ByVal hBrush As Long) _
    As Long
Private Declare Function CreateBrushIndirect Lib "gdi32" ( _
    lpLogBrush As LOGBRUSH) _
    As Long
Private Declare Function DeleteObject Lib "gdi32" ( _
    ByVal hObject As Long) _
    As Long
'  
Private Declare Function SetParent Lib "user32" ( _
    ByVal hWndChild As Long, _
    ByVal hWndNewParent As Long) _
    As Long
Private Declare Function SetWindowLong Lib "user32" _
    Alias "SetWindowLongA" ( _
    ByVal hwnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) _
    As Long
Private Declare Function SetCapture Lib "user32" ( _
    ByVal hwnd As Long) _
    As Long
Private Declare Function ReleaseCapture Lib "user32" () _
    As Long
Private Declare Function GetCapture Lib "user32" () _
    As Long
Private Declare Function GetWindowRect Lib "user32" ( _
    ByVal hwnd As Long, _
    lpRect As RECT) _
    As Long
' 
Private Declare Function GetPixel Lib "gdi32" ( _
    ByVal hdc As Long, _
    ByVal X As Long, _
    ByVal Y As Long) _
    As Long

' 
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENINNER = &H8
Private Const BDR_SUNKENOUTER = &H2
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const BF_BOTTOM = &H8
Private Const BF_LEFT = &H1
Private Const BF_RIGHT = &H4
Private Const BF_TOP = &H2
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)

' 
Private Const BS_SOLID = 0
Private Const HS_SOLID = 8

Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_TOOLWINDOW = &H80

Private R As RECT
Private R2 As RECT
Private R_in As RECT
Private LB As LOGBRUSH
Private StatusButton As Boolean

'  
Const m_def_ColorSelected = 0
' 
Dim m_ColorSelected As OLE_COLOR
' 
Event SelectedClick()

'   
Private Sub picPopup_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If X < 0 Or X > picPopup.Width / Screen.TwipsPerPixelX _
        Or Y < 0 Or Y > picPopup.Height / Screen.TwipsPerPixelY Then
        HidePopup
    ElseIf Button = vbLeftButton Then
        ColorSelected = GetPixel(picPopup.hdc, X, Y)
        HidePopup
        RaiseEvent SelectedClick
    Else
        '  
        HidePopup
    End If
End Sub

'   
Private Sub UserControl_ExitFocus()
    If picPopup.Visible Then HidePopup
End Sub

'     
Private Sub UserControl_Initialize()
    SetWindowLong picPopup.hwnd, GWL_EXSTYLE, WS_EX_TOOLWINDOW
    SetParent picPopup.hwnd, 0
End Sub

' ,     
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If X > 0 And X < R.Right Then
    DrawEdge hdc, R, EDGE_SUNKEN, BF_RECT
    RaiseEvent SelectedClick
    StatusButton = True
Else
    DrawEdge hdc, R2, EDGE_SUNKEN, BF_RECT
    StatusButton = False
End If
  SendKeys vbNullChar
End Sub

' ,     
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
If StatusButton Then
  DrawEdge hdc, R, EDGE_RAISED, BF_RECT
Else
    DrawEdge hdc, R2, EDGE_RAISED, BF_RECT
    ShowPopUp
End If
  
  SendKeys vbNullChar
End Sub

'  
Private Sub UserControl_Paint()
Dim hBrush As Long
  
  '  
  DrawEdge hdc, R, EDGE_RAISED, BF_RECT
  DrawEdge hdc, R2, EDGE_RAISED, BF_RECT
  '   
  LB.lbColor = m_ColorSelected
  LB.lbStyle = BS_SOLID
  LB.lbHatch = HS_SOLID
  ' 
  hBrush = CreateBrushIndirect(LB)
  '    
  FillRect hdc, R_in, hBrush
  ' ,  
  DeleteObject hBrush
  '   
  DrawEdge hdc, R_in, EDGE_ETCHED, BF_RECT
End Sub

Private Sub UserControl_Resize()
  '   
  SetRect R, 0, 0, ScaleWidth - 16, ScaleHeight
  SetRect R2, ScaleWidth - 16, 0, ScaleWidth, ScaleHeight
  '   () 
  SetRect R_in, 4, 4, R.Right - 4, ScaleHeight - 4
End Sub

Private Sub UserControl_Show()
    UserControl_Paint
End Sub

'    
Public Property Get ColorSelected() As OLE_COLOR
    ColorSelected = m_ColorSelected
End Property

Public Property Let ColorSelected(ByVal New_ColorSelected As OLE_COLOR)
    m_ColorSelected = New_ColorSelected
    PropertyChanged "ColorSelected"
    UserControl_Paint
End Property

Private Sub UserControl_InitProperties()
    m_ColorSelected = m_def_ColorSelected
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_ColorSelected = PropBag.ReadProperty("ColorSelected", m_def_ColorSelected)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("ColorSelected", m_ColorSelected, m_def_ColorSelected)
End Sub

'  
Private Sub ShowPopUp()
Dim tmpRect As RECT
Dim lTop As Long, lLeft As Long
    GetWindowRect hwnd, tmpRect
    
    lTop = tmpRect.Bottom * Screen.TwipsPerPixelY
    lLeft = tmpRect.Left * Screen.TwipsPerPixelX
    With picPopup
        .Top = lTop
        .Left = lLeft
        .Visible = True
        .ZOrder
    End With
    DoEvents
    '     
    SetCapture picPopup.hwnd
End Sub

'  
Private Sub HidePopup()
    If GetCapture = picPopup.hwnd Then
        ReleaseCapture
    End If
    picPopup.Visible = False
    DoEvents
End Sub
